Index: CMT/HEAD/source/cmt_generators.cxx
===================================================================
--- CMT/HEAD/source/cmt_generators.cxx	(revision 586)
+++ CMT/HEAD/source/cmt_generators.cxx	(revision 588)
@@ -3198,45 +3843,161 @@
 
 //--------------------------------------------------
-void DependencyGenerator::prepare_header_file_filters ()
-{
-//   Use::UsePtrVector& uses = Use::get_ordered_uses ();
-  Use::UsePtrVector uses (Use::get_ordered_uses ());
-  uses.push_back (&Use::current ());
-  for (int i = uses.size () - 1; i >= 0; i--)
-    {
-      Use* use = uses[i];
-      if (use->discarded) continue;
-      if (use->m_hidden) continue;
-      if (!use->located ()) continue;
-
-      cmt_string package_name = use->get_package_name ();
-      if (package_name == "CMT") continue;
-
-      Symbol* filter_macro = Symbol::find (package_name + "_header_file_filter");
-      if (filter_macro == 0) continue;
-
-      Symbol* stamp_macro = Symbol::find (package_name + "_header_file_stamp");
-      cmt_string stamp;
-      if (stamp_macro != 0)
-        {
-          stamp = stamp_macro->resolve_macro_value ();
-        }
-      else
-        {
-          use->get_full_path (stamp);
-          stamp += CmtSystem::file_separator ();
-          if (use->style == mgr_style) stamp += "mgr";
-          else stamp += "cmt";
-          stamp += CmtSystem::file_separator ();
-          stamp += "cmt_header_file.stamp";
-          //stamp += "cmt_all_headers.stamp";
-          //<package>/cmt/cmt_all_headers.stamp
-        }
-      if (!CmtSystem::test_file (stamp)) continue;
-
-      cmt_regexp* filter = new cmt_regexp (filter_macro->resolve_macro_value ());
-      assert (filter != 0);
-
-      m_deps_builder.add_header_filter (use, filter, stamp);
-    }
-}
+int DependencyGenerator::fill_dependencies (cmt_string& dependencies)
+{
+  CmtSystem::cmt_string_vector sources;
+  for (int i = 0; i < m_source_files.size (); i++)
+    {
+      const SourceFile& file = m_source_files[i];
+      sources.push_back (file.name ());
+    }
+  return fill_dependencies (dependencies, sources);
+}
+
+//--------------------------------------------------
+int DependencyGenerator::fill_dependencies (cmt_string& dependencies,
+					    const CmtSystem::cmt_string_vector& sources)
+{
+  int retval (0);
+  cmt_string file_name;
+  cmt_string compressed_name;
+
+  for (int i = 0; i < sources.size (); i++)
+    {
+      file_name = sources[i];
+      //set_full_name (full_name, file_name);
+      CmtSystem::reduce_file_separators (file_name);
+      if (file_name == "") continue;
+      CmtSystem::compress_path (file_name, compressed_name);
+      file_name = compressed_name;
+      //cerr << "file_name: " << file_name << endl;     
+      if (file_name == "") continue;
+
+      const cmt_string& line = build (file_name);
+      if (CmtError::has_pending_error ())
+	{
+	  //	  if (CmtError::get_last_error_code () == CmtError::file_access_error)
+	  return -1;
+	}
+      
+      //cerr << "line: " << line << endl;     
+      add_line_to_text (line, dependencies);
+      //cerr << "dependencies: " << dependencies << endl;     
+    }
+
+  return retval;
+}
+
+//--------------------------------------------------
+int DependencyGenerator::set_source_files (const CmtSystem::cmt_string_vector& files)
+{
+  m_source_files.clear ();
+
+  for (int j = 0; j < files.size (); j++)
+    {
+      const cmt_string& name = files[j];
+      if (name == "") continue;
+
+      bool included = false;
+      for (int k = m_source_files.size () - 1; k >= 0; k--)
+	if (m_source_files[k].name () == name)
+	  {
+	    included = true;
+	    break;
+	  }
+      if (included) continue;
+      
+      SourceFile& source = m_source_files.add ();
+      source.set (name, Language::null (), "");
+    }
+      
+  if (m_source_files.size ()) return m_source_files.size ();
+  else return set_source_files ();
+}
+
+//--------------------------------------------------
+int DependencyGenerator::set_source_files ()
+{
+  if (0 == m_constituent && 0 != m_name.size ())
+    m_constituent = Constituent::find (m_name);
+  if (0 == m_constituent) return 0;
+
+  m_source_files.clear ();
+
+  const CmtSystem::cmt_string_vector& sources = m_constituent->modules;
+  const cmt_vector<cmt_regexp>& excludes = m_constituent->exclude_exprs;
+  const cmt_vector<cmt_regexp>& selects = m_constituent->select_exprs;
+
+  cmt_string file_name, full_name;
+  cmt_string compressed_name;
+  cmt_string visited, token;
+
+  for (int i = 0; i < sources.size (); i++)
+    {
+      file_name = sources[i];
+      set_full_name (full_name, file_name);
+      if (full_name == "") continue;
+      
+      CmtSystem::compress_path (full_name, compressed_name);
+      full_name = compressed_name;
+      
+      static CmtSystem::cmt_string_vector files;
+      
+      get_all_files (full_name, excludes, selects, files);
+      
+      for (int j = 0; j < files.size (); j++)
+	{
+	  const cmt_string& name = files[j];
+              
+	  if (name == "") continue;
+	  
+	  cmt_string suffix;
+	  CmtSystem::get_suffix (name, suffix);
+	  Language& language = Language::find_with_suffix (suffix);
+
+	  if ((m_constituent->type == Application || m_constituent->type == Library)
+	      && language != Language::null () && language.native_dependencies ())
+	    continue;
+
+	  bool included = false;
+	  for (int k = m_source_files.size () - 1; k >= 0; k--)
+	    if (m_source_files[k].name () == name)
+	      {
+		included = true;
+		break;
+	      }
+	  if (included) continue;
+	  
+	  SourceFile& source = m_source_files.add ();
+	  source.set (name, language, "");
+	}
+    }
+  return m_source_files.size ();
+}
+
+//--------------------------------------------------
+/**
+ *  Returns 0, if each file in files is found in m_source_files,
+ *  otherwise returns 1
+ */
+//--------------------------------------------------
+int DependencyGenerator::validate (const CmtSystem::cmt_string_vector& files) const
+{
+  int n_invalid = 0;
+  for (int i = 0; i < files.size (); i++)
+    {
+      bool valid = false;
+      for (int j = 0; j < m_source_files.size (); j++)
+	if (files[i] == m_source_files[j].name ())
+	  {
+	    valid = true;
+	    break;
+	  }
+      if (!valid)
+	{
+	  n_invalid += 1;
+	  break;
+	}
+    }
+
+  return n_invalid;
+}
Index: CMT/HEAD/source/cmt_generators.h
===================================================================
--- CMT/HEAD/source/cmt_generators.h	(revision 586)
+++ CMT/HEAD/source/cmt_generators.h	(revision 588)
@@ -11,4 +11,5 @@
 #include "cmt_fragment.h"
 #include "cmt_generator.h"
+#include "cmt_deps_builder.h"
 
 class AnyDocumentGenerator : public CmtGenerator
@@ -36,5 +37,7 @@
   void build (const cmt_string& package,
               const Constituent& constituent,
+	      bool& dependencies,
 	      const cmt_string& file = "");
+  // returned bool& value indicates whether dependencies_fragment added to makefile
 
 private:
@@ -44,5 +47,8 @@
 		     const cmt_string& output_suffix);
 
+  Variable m_FILEEXTENSION;
+
   FragmentHandle document_header_fragment;
+  FragmentHandle dependency_fragment;
 };
 
@@ -53,5 +59,7 @@
   void build (const cmt_string& package,
               const Constituent& constituent,
+	      bool& dependencies,
 	      const cmt_string& file = "");
+  // returned bool& value indicates whether dependencies_fragment added to makefile
 
 protected:
@@ -63,4 +71,5 @@
   void prepare_proto_file (const cmt_string& file);
   void module_file_action (SourceFile& file, const Constituent& constituent);
+  void fill_names_outputs ();
 
   FragmentHandle library_header_fragment;
@@ -214,14 +223,47 @@
 };
 
+class PackagesMakefileGenerator : public CmtGenerator
+{
+public:
+  PackagesMakefileGenerator ();
+  void build (const cmt_string& package,
+	      const cmt_string& file);
+  //	      const CmtSystem::cmt_string_vector& arguments);
+
+private:
+  void reset ();
+
+  Variable m_DEPENDENCIES;
+  Variable m_PACKAGEMGRPATH;
+  Variable m_PACKAGEFULLNAME;
+  Variable m_ISLOCAL;
+
+  FragmentHandle packages_header_fragment;
+  FragmentHandle packages_trailer_fragment;
+  FragmentHandle package_fragment;
+};
+
 class DependencyGenerator : public CmtGenerator
 {
 public:
   void build (const CmtSystem::cmt_string_vector& arguments);
+  void prepare_includes ();
   void prepare_header_file_filters ();
- 
-private:
-  void add_line_to_text (const cmt_string& line, cmt_string& text);
+  void reset ();
+
+protected:
+  int set_source_files ();
+  int set_source_files (const CmtSystem::cmt_string_vector& files);
+  int validate (const CmtSystem::cmt_string_vector& files) const;
+
+private:
+  void add_line_to_text (const cmt_string& line, cmt_string& text) const;
   cmt_string build (const cmt_string& file_name);
+  int fill_dependencies (cmt_string& dependencies,
+			 const CmtSystem::cmt_string_vector& source);
+  int fill_dependencies (cmt_string& dependencies);
+  DepsBuilder m_deps_builder;
   bool m_stamps;
+  cmt_string m_name;
 };
 
Index: CMT/HEAD/source/cmt_parser.cxx
===================================================================
--- CMT/HEAD/source/cmt_parser.cxx	(revision 586)
+++ CMT/HEAD/source/cmt_parser.cxx	(revision 588)
@@ -1888,4 +1888,6 @@
   Cmt::reset_all_sets_done ();
   Symbol::all_set ();
+  if (CmtSystem::testenv ("CMTBCAST"))
+    CmtSystem::putenv ("CMTBCAST", "");
 
   for (i = 0; i < uses.size (); i++)
@@ -2125,5 +2127,6 @@
       return;
     }
-  Generator::build_constituent_makefile (*constituent, out);
+  bool dependencies (false);
+  Generator::build_constituent_makefile (*constituent, dependencies, out);
 //   if (ap.arguments.size () > 0) 
 //     {
@@ -2167,6 +2170,10 @@
       return;
     }
-  Generator::build_constituent_makefile (*constituent, out);
-  if (!constituent->has_target_tag) return;
+  if (!constituent->has_target_tag)
+    {
+      bool dependencies (false);
+      Generator::build_constituent_makefile (*constituent, dependencies, out);
+      return;
+    }
   //  cerr << "constituent: " << name << endl;
 
@@ -2266,4 +2273,12 @@
 	}
     }
+
+  int retval (0);
+
+  bool dependencies (false);
+  Generator::build_constituent_makefile (*constituent, dependencies, out);
+
+  if (dependencies)
+    retval = Generator::build_dependencies_infile (constituent, outdir/*, usecmt*/);
 }
 
@@ -2300,4 +2315,8 @@
       return;
     }
+  do_check_configuration (ap);
+  if (CmtError::get_last_error_code () == CmtError::configuration_error)
+    return;
+
   set_standard_macros ();
 
@@ -2415,15 +2434,104 @@
     }
 
+  int retval (0);
+
   Generator::build_constituents_makefile (Me.m_current_package, out);
   //  Generator::build_constituents_makefile (Me.m_current_package, ap.arguments);
 
+  retval = Generator::build_library_links_infile (outdir);
+  if (0 != retval) return;
+
   const Constituent::ConstituentVector& constituents =
     Constituent::constituents ();
+  bool deps (false);
   for (int n = 0; n < constituents.size (); n++)
     {
       const Constituent& constituent = constituents[n];
       if (constituent.has_target_tag) continue;
-      Generator::build_constituent_infile (constituent, outdir, usecmt);
-    }
+
+      retval = Generator::build_constituent_infile (constituent, outdir, usecmt);
+      if (0 != retval) return;
+
+      if (!deps)
+	if (constituent.type == Application ||
+	    constituent.type == Library ||
+	    (constituent.type == Document &&
+	     FragmentHandle (constituent.generator).need_dependencies ()))
+	  {
+	    deps = true;
+	  }
+    }
+
+  if (deps)
+    retval = Generator::build_dependencies_infile (0, outdir, usecmt);
+}
+
+//----------------------------------------------------------
+void Cmt::do_build_broadcast_config (const ArgParser& ap)
+{
+  if (CmtLock::check () == CmtLock::locked_by_another_user)
+    {
+      CmtError::set (CmtError::conflicting_lock, "build_broadcast_config>");
+      return;
+    }
+  set_standard_macros ();
+
+  cmt_string out, outdir, name ("broadcast");
+  for (int i = 0; i < ap.arguments.size (); i++)
+    {
+      const cmt_string& arg = ap.arguments[i];
+      if (arg.substr (0, 5) == "-out=")
+	{
+	  arg.substr (5, out);
+	  CmtSystem::dirname (out, outdir);
+	  CmtSystem::name (out, name);
+	}
+    }
+
+  cmt_string tag;
+  {
+    Symbol* macro = Symbol::find ("tag");
+    if (macro != 0)
+      {
+	tag = macro->build_macro_value ();
+	Symbol::expand (tag);
+      }
+  }
+  cmt_string file (tag + "_" + name);
+  //  cmt_string file (tag + "_uses");
+  if (Cmt::build_nmake ())
+    file += ".nmake";
+  else
+    file += ".make";
+  if (outdir != "")
+    {
+      if (outdir [outdir.size () - 1] != CmtSystem::file_separator ())
+	outdir += CmtSystem::file_separator ();
+      file = outdir + file;
+    }
+
+  ofstream t (file);
+  if (!t)
+    {
+      CmtError::set (CmtError::file_access_error, file);
+      return;
+    }
+  t.exceptions (ios::failbit | ios::badbit);
+  try
+    {
+//       Symbol* symbol = Symbol::find ("use_requirements");
+//       if (symbol != 0)
+// 	symbol->show_macro (Make, t);
+      const cmt_string pattern = "^use_requirements$|.*_root$";
+      print_macros (Make, pattern, t);
+      t.close (); // ios_base::failbit
+    }
+  catch (const ios::failure& e)
+    {
+      CmtSystem::close_ostream (NULL, file + ": " + cmt_string (e.what ()));
+    }
+
+  Generator::build_packages_makefile (Me.m_current_package, out);
+  //  Generator::build_uses_makefile (Me.m_current_package, out);
 }
 
@@ -2468,5 +2576,19 @@
   {
     Symbol* macro = Symbol::find ("shlibsuffix");
-    if (macro == 0) return;
+    if (macro == 0)
+      {
+	if (strlen (ap.extra_file.c_str ()) == 0)
+	  {
+	    CmtError::set(CmtError::configuration_error, "shlibsuffix undefined");
+	  }
+	else
+	  { // we are most likely reading empty library_links.in without CMT
+	    if (CmtMessage::active (Verbose))
+	      CmtMessage::warning
+		(CmtError::get_error_name (CmtError::configuration_error)
+		 + ": shlibsuffix undefined");
+	  }
+	return;
+      }
     shlibsuffix = macro->build_macro_value ();
     Symbol::expand (shlibsuffix);
@@ -2716,14 +2838,29 @@
       if (action_setup != get_action () &&
 	  none_style != use.style &&
-	  0 == Project::find_in_cmt_paths (use.real_path).size ())
+	  0 == Project::get_current ())
+	  //	  0 == Project::find_in_cmt_paths (use.real_path).size ())
 	{
-	  if (0 == CmtSystem::getenv ("CMTPEDANTIC").size () &&
-	      0 == CmtSystem::getenv ("PEDANTIC").size ())
-	    CmtMessage::warning
-	      (CmtError::get_error_name (CmtError::configuration_error)
-	       + ": Current use outside CMTPATH: " + use.get_info ());
-	  else
-	    CmtError::set(CmtError::configuration_error,
-			  "Current use outside CMTPATH: " + use.get_info ());
+	  bool use_cmtpath_pattern (false);
+	  static CmtPathPattern::CmtPathPatternVector& CmtPathPatterns = CmtPathPattern::patterns ();
+	  for (int i = 0; i < CmtPathPatterns.size (); i++)
+	    {
+	      CmtPathPattern& p = CmtPathPatterns[i];
+	      if (p.use->get_package ()->is_cmt () || p.is_constant ()) continue;
+	      use_cmtpath_pattern = true;
+	      break;
+	    }
+	  if (use_cmtpath_pattern)
+	    // non-constant cmtpath_pattern found that
+	    // cannot be applied for package outside CMTPATH
+	    {
+	      if (0 == CmtSystem::getenv ("CMTPEDANTIC").size () &&
+		  0 == CmtSystem::getenv ("PEDANTIC").size ())
+		CmtMessage::warning
+		  (CmtError::get_error_name (CmtError::configuration_error)
+		   + ": Package outside CMTPATH: " + use.get_info ());
+	      else
+		CmtError::set(CmtError::configuration_error,
+			      "Package outside CMTPATH: " + use.get_info ());
+	    }
 	}
     }
@@ -2737,5 +2874,6 @@
   static CmtSystem::cmt_string_vector tags;
 
-  CmtSystem::split (Me.m_extra_tags, " \t,", tags);
+  if (action_build_constituents_config != get_action ())
+    CmtSystem::split (Me.m_extra_tags, " \t,", tags);
 
   for (int i = 0; i < tags.size (); i++)
@@ -3848,10 +3986,26 @@
   uses.push_back (&Use::current ());
   int i;
+  cmt_string cmtinstallarea = "";
+  cmt_string tag = "";
   cmt_string shlibsuffix;
-  cmt_string symunlink;
+  cmt_string symunlinkcmd;
 
   {
     Symbol* macro = Symbol::find ("shlibsuffix");
-    if (macro == 0) return;
+    if (macro == 0)
+      {
+	if (strlen (ap.extra_file.c_str ()) == 0)
+	  {
+	    CmtError::set(CmtError::configuration_error, "shlibsuffix undefined");
+	  }
+	else
+	  { // we are most likely reading empty library_links.in without CMT
+	    if (CmtMessage::active (Verbose))
+	      CmtMessage::warning
+		(CmtError::get_error_name (CmtError::configuration_error)
+		 + ": shlibsuffix undefined");
+	  }
+	return;
+      }
     shlibsuffix = macro->build_macro_value ();
     Symbol::expand (shlibsuffix);
@@ -3860,19 +4014,51 @@
   {
     Symbol* macro = Symbol::find ("symunlink");
-    if (macro == 0) return;
-    symunlink = macro->build_macro_value ();
-    Symbol::expand (symunlink);
+    if (macro != 0)
+      {
+	symunlinkcmd = macro->build_macro_value ();
+	Symbol::expand (symunlinkcmd);
+      }
   }
 
-//   for (i = 0; i < Uses.size (); i++)
-//     {
-//       Use* use = Uses[i];
+  if (current_use.get_strategy ("InstallArea"))
+    {
+      const CmtInstallAreaMgr& ia_mgr = CmtInstallAreaMgr::instance ();
+      
+      cmt_string s1 = ia_mgr.get_installarea ();
+
+      {
+        Symbol* symbol = Symbol::find ("CMTINSTALLAREA");
+        if (symbol != 0)
+          {
+            s1 = symbol->build_macro_value ();
+	    Symbol::expand (s1);
+          }
+      }
+
+      cmtinstallarea = s1;
+                  
+      cmt_string s2;
+
+      {
+        Symbol* macro = Symbol::find ("tag");
+        if (macro != 0)
+          {
+            s2 = macro->build_macro_value ();
+	    Symbol::expand (s2);
+          }
+      }
+
+      tag = s2;
+    }
+
   for (i = 0; i < uses.size (); i++)
     {
       Use* use = uses[i];
 
+      if (use == 0) continue;
       if (use->discarded) continue;
       if (use->m_hidden) continue;
 
+      if (use->get_package_name () == "CMT") continue;
       if (!use->located ())
         {
@@ -3880,148 +4066,8 @@
 			       + " " + use->version + " " + use->path
 			       + " not found");
-	      /*
-          if (!Me.m_quiet)
-            {
-              cerr << "#CMT> package " << use->get_package_name () <<
-		" " << use->version << " " << use->path << 
-		" not found" <<
-		endl;
-            }
-	      */
-        }
-      else
-        {
-          if (use->get_package_name () == "CMT") continue;
-//           if (use->get_package_name () == current_use.get_package_name ()) continue;
-
-          cmt_string s;
-
-          s = use->get_package_name ();
-          s += "_libraries";
-
-          Symbol* libraries_macro = Symbol::find (s);
-
-          if (libraries_macro == 0) continue;
-
-          cmt_string libraries = libraries_macro->build_macro_value ();
-	  Symbol::expand (libraries);
-
-          static CmtSystem::cmt_string_vector values;
-
-          CmtSystem::split (libraries, " \t", values);
-
-          for (int j = 0; j < values.size (); j++)
-            {
-              const cmt_string& library = values[j];
-
-              static cmt_string libname;
-              static cmt_string name;
-
-              // Is it a simple name or a complete path?
-
-              libname = library;
-              Symbol::expand (libname);
-
-              if (CmtSystem::absolute_path (libname))
-                {
-                  /**
-                   *   We assume here that "library" contains a complete path.
-                   *   (including the complete syntax libxxx.so)
-                   */
-
-                  cmt_string suffix;
-                  CmtSystem::basename (library, name);
-                }
-              else
-                {
-                  /**
-                   *   Here we expect that only the base name of the library
-                   *   is given : ie it should not contain the "lib" prefix, 
-                   *   nor the suffix .so, nor any path prefix.
-                   *    This of course should generally correspond to a constituent name.
-                   */
-
-                  name = "lib";
-                  name += libname;
-                  name += ".";
-                  name += shlibsuffix;
-                }
-
-              Symbol::expand (libname);
-
-              if (current_use.get_strategy ("InstallArea"))
-                {
-                  const CmtInstallAreaMgr& ia_mgr = CmtInstallAreaMgr::instance ();
-
-                  cmt_string s1 = ia_mgr.get_installarea ();
-
-                  {
-                    Symbol* symbol = Symbol::find ("CMTINSTALLAREA");
-                    if (symbol != 0)
-                      {
-                        s1 = symbol->build_macro_value ();
-			Symbol::expand (s1);
-                      }
-                  }
-                  
-                  cmt_string s2;
-
-                  {
-                    Symbol* macro = Symbol::find ("tag");
-                    if (macro != 0)
-                      {
-                        s2 = macro->build_macro_value ();
-			Symbol::expand (s2);
-                      }
-                  }
-
-		  // Now deleting the reference file
-
-                  s = symunlink;
-                  s += " ";
-                  s += s1;
-                  s += CmtSystem::file_separator ();
-                  s += s2;
-                  s += CmtSystem::file_separator ();
-                  s += "lib";
-                  s += CmtSystem::file_separator ();
-                  s += name;
-                  s += ".cmtref";
-                  s += " ";
-                  s += s1;
-                  s += CmtSystem::file_separator ();
-                  s += s2;
-                  s += CmtSystem::file_separator ();
-                  s += "lib";
-                  s += CmtSystem::file_separator ();
-                  s += name;
-                }
-              else
-                {
-                  s = symunlink;
-                  s += " ../$(";
-                  s += current_use.get_package_name ();
-                  s += "_tag)/";
-                  s += name;
-                }
-
-              Symbol::expand (s);
-
-              if (!Me.m_quiet) cerr << s << endl;
-
-              int status = CmtSystem::execute (s);
-
-              if (status != 0)
-                {
-		  //                  if (status != 2) CmtError::set (CmtError::execution_error, s);
-                  CmtError::set (CmtError::execution_error, s);
-
-                  CmtMessage::warning ("Cannot remove the symbolic link " + s);
-		  //                  cerr << "#CMT> Cannot remove the symbolic link " << s << endl;
-
-                  break;
-                }
-            }
-        }
+	  continue;
+        }
+
+      use->remove_library_links (cmtinstallarea, tag, shlibsuffix, symunlinkcmd);
     }
 }
@@ -6417,4 +6463,5 @@
     case action_build_constituents_makefile :
     case action_build_constituents_config :
+    case action_build_broadcast_config :
     case action_build_dependencies :
     case action_build_library_links :
@@ -6535,4 +6582,5 @@
     case action_build_constituents_makefile :
     case action_build_constituents_config :
+    case action_build_broadcast_config :
     case action_build_dependencies :
     case action_build_library_links :
@@ -6642,4 +6690,5 @@
     case action_build_constituents_makefile :
     case action_build_constituents_config :
+    case action_build_broadcast_config :
     case action_build_dependencies :
     case action_build_library_links :
@@ -6789,4 +6838,5 @@
         case action_build_constituents_makefile :
         case action_build_constituents_config :
+	case action_build_broadcast_config :
         case action_build_dependencies :
         case action_build_library_links :
@@ -6911,4 +6961,7 @@
 	case action_build_constituents_config :
 	  do_build_constituents_config (ap);
+	  break;
+	case action_build_broadcast_config :
+	  do_build_broadcast_config (ap);
 	  break;
 	case action_build_dependencies :
@@ -9042,9 +9095,17 @@
 	    else
 	      {
-		if (Me.m_action == action_build_constituents_makefile ||
-		    Me.m_action == action_build_constituents_config)
-		  CmtMessage::warning ("package " + import +
-				       " cannot be imported (requested for " +
-				       constituent.name +")");
+		if ((!constituent.has_target_tag &&
+		     Me.m_action == action_build_constituents_config)
+		    ||
+		    (constituent.has_target_tag &&
+		     Me.m_action == action_build_constituent_config))
+		  CmtMessage::warning
+		    (CmtError::get_error_name (CmtError::configuration_error)
+		     + ": package " + import
+		     + " cannot be imported (requested for "
+		     + (constituent.type == Application ?
+			"application " : "library ")
+		     + constituent.name +")");
+		
 		if (Cmt::get_debug ())
 		  {
@@ -9052,4 +9113,6 @@
 			 << ("package " + import +
 			     " cannot be imported (requested for " +
+			     (constituent.type == Application ?
+			      "application " : "library ") +
 			     constituent.name +")")  << endl;
 		  }
Index: CMT/HEAD/source/cmt_parser.h
===================================================================
--- CMT/HEAD/source/cmt_parser.h	(revision 586)
+++ CMT/HEAD/source/cmt_parser.h	(revision 588)
@@ -228,4 +228,5 @@
   action_build_constituents_makefile,
   action_build_constituents_config,
+  action_build_broadcast_config,
   action_build_dependencies,
   action_build_library_links,
Index: CMT/HEAD/source/cmt_symbol.cxx
===================================================================
--- CMT/HEAD/source/cmt_symbol.cxx	(revision 586)
+++ CMT/HEAD/source/cmt_symbol.cxx	(revision 588)
@@ -1907,5 +1907,5 @@
 
   */
-cmt_string Symbol::resolve_macro_value (const cmt_string& tag_name)
+cmt_string Symbol::resolve_macro_value (const cmt_string& tag_name) const
 {
   cmt_string temp = builder->build (*this, tag_name);
@@ -1933,4 +1933,5 @@
       (action != action_build_constituents_config) &&
       (action != action_build_constituent_config) &&
+      (action != action_build_broadcast_config) &&
       (action != action_show_macros) &&
       (action != action_show_actions) &&
@@ -1952,4 +1953,5 @@
           (action == action_build_constituents_config) ||
           (action == action_build_constituent_config) ||
+          (action == action_build_broadcast_config) ||
           (action == action_load) ||
           (!Cmt::get_quiet ()))
@@ -1973,5 +1975,6 @@
       else if (action == action_build_tag_makefile ||
 	       action == action_build_constituents_config ||
-	       action == action_build_constituent_config)
+	       action == action_build_constituent_config ||
+	       action == action_build_broadcast_config)
         {
             /* 
@@ -1997,4 +2000,5 @@
           (action == action_build_constituents_config) ||
           (action == action_build_constituent_config) ||
+          (action == action_build_broadcast_config) ||
           (action == action_load) ||
           (!Cmt::get_quiet ()))
@@ -3287,5 +3291,5 @@
 
 //-------------------------------------------------------------
-bool Symbol::check_tag_used (Tag* tag)
+bool Symbol::check_tag_used (const Tag* tag)
 {
   if (tag == 0) return (false);
Index: CMT/HEAD/source/cmt_symbol.h
===================================================================
--- CMT/HEAD/source/cmt_symbol.h	(revision 586)
+++ CMT/HEAD/source/cmt_symbol.h	(revision 588)
@@ -102,5 +102,5 @@
   static void filter_path_value (const cmt_string& name, cmt_string& text);
 
-  static bool check_tag_used (Tag* tag);
+  static bool check_tag_used (const Tag* tag);
 
   static cmt_string get_env_value (const cmt_string& name);
@@ -122,5 +122,5 @@
   int print_macro (PrintMode mode, ostream& out = cout) const;
   cmt_string clean_macro_value () const;
-  cmt_string resolve_macro_value (const cmt_string& tag_name = "");
+  cmt_string resolve_macro_value (const cmt_string& tag_name = "") const;
   void show_macro (PrintMode mode, ostream& out = cout);
   //  void show_macro (PrintMode mode);
Index: CMT/HEAD/source/cmt_system.cxx
===================================================================
--- CMT/HEAD/source/cmt_system.cxx	(revision 586)
+++ CMT/HEAD/source/cmt_system.cxx	(revision 588)
@@ -674,5 +674,5 @@
   if (::unlink (name) != 0)
     {
-      CmtMessage::error ("Cannot remove file " + name);
+      //      CmtMessage::error ("Cannot remove file " + name);
       //      cerr << "#CMT> Cannot remove file " << name << endl;
       return (false);
